package dev.shadowsoffire.apotheosis.mixin;

package .tmp;

import dev.shadowsoffire.apotheosis.util.INBTSensitiveFallingBlock;
import javax.annotation.Nullable;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.item.FallingBlockEntity;
import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({FallingBlockEntity.class})
public abstract class FallingBlockEntityMixin extends Entity {
  public FallingBlockEntityMixin(EntityType<?> pType, Level pLevel) {
    super(pType, pLevel);
  }
  
  @Nullable
  public ItemEntity m_19998_(ItemLike pItem) {
    if (pItem instanceof INBTSensitiveFallingBlock) {
      INBTSensitiveFallingBlock nbtSensitive = (INBTSensitiveFallingBlock)pItem;
      if ((ths()).f_31944_ != null)
        return ths().m_5552_(nbtSensitive.toStack(ths().m_31980_(), (ths()).f_31944_), 0.0F); 
    } 
    return ths().m_20000_(pItem, 0);
  }
  
  private FallingBlockEntity ths() {
    return (FallingBlockEntity)this;
  }
}
